struct VertexToPixel
{
    float4 Position     : POSITION;
    float4 Color        : COLOR0;
};

float4x4 xViewProjection;

VertexToPixel ColoredVertexShader( float4 inPos : POSITION, float4 inTexCoord : TEXCOORD0)
{
    VertexToPixel Output = (VertexToPixel)0;
    
    Output.Position =mul(inPos, xViewProjection);
    Output.Color.x = inTexCoord.x; 
    Output.Color.y = inTexCoord.y;  
    Output.Color.z = inTexCoord.z;     
    
    return Output;    
}

technique ColoredCube
{
    pass Pass0
    {        
        VertexShader = compile vs_1_1 ColoredVertexShader();
        PixelShader = NULL;
    }
}