// Dataflow von Vertex Shader zu Pixel Shader:
struct VertexToPixel
{
    float4 Position     : POSITION0;
    float4 TexCoords    : TEXCOORD0;
};
// Dataflow von PixelShader -> Output
struct PixelToFrame
{
    float4 Color : COLOR0;
};


// Transfer Textur:
Texture xTranferTexture;
//??

// Viewing & Projection Matrix
float4x4 xViewProjection;
float4x4 xWorld;
texture xVolumeTexture
< 
    string ResourceType = "VOLUME"; 
    //string function = "GenerateVolumeMap"; 
>;
// Gradient-Textur:
texture xGradientTexture
< 
    string ResourceType = "VOLUME"; 
    //string function = "GenerateVolumeMap"; 
>;

// Sampler fr Volumstextur anlegen
sampler3D VolumeTexture =
sampler_state
{
    texture = (xVolumeTexture);
    MipFilter = anisotropic;
    MinFilter = anisotropic;
    MagFilter = anisotropic;
    
    AddressU = BORDER;
    AddressV = BORDER;
    AddressW = BORDER;
};

// Sampler fr Volumstextur anlegen
sampler3D GradientTexture =
sampler_state
{
    texture = (xGradientTexture);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    
    AddressU = CLAMP;
    AddressV = CLAMP;
    AddressW = CLAMP;
};


// Sampler fr TransferFunktions-Textur
sampler TransferTextureSampler = 
sampler_state 
{ 
	texture = <xTranferTexture>; 
	magfilter = LINEAR; 
	minfilter = LINEAR; 
	mipfilter=LINEAR; 
	AddressU = mirror; 
	AddressV = mirror;
};

// Vertex Shader:
VertexToPixel VertexMapper( float4 inPos : POSITION, float4 inTexCoords : TEXCOORD0)
{
    VertexToPixel Output;
    Matrix Mat = mul(xWorld, xViewProjection);
    Output.Position = mul(inPos, Mat);
    Output.TexCoords = inTexCoords;
    return Output;
}

// Pixel Shader:
PixelToFrame SlicePixel(VertexToPixel PSIn)
{
    PixelToFrame Output;
    Output.Color.xyzw = 0.0;

	float4 samplePoint;
	samplePoint.xyz = PSIn.TexCoords.xyz;
	samplePoint.w = 0.0;

	float4 intensity = tex3Dlod(VolumeTexture, samplePoint ) * 16;

	float4 transferlookup;
	transferlookup.y = intensity.x;
	transferlookup.x = 0.0;
	transferlookup.zw = 0.0;
		
	float4 transfered = tex2Dlod(TransferTextureSampler, transferlookup);
	
	Output.Color.xyz = transfered.xyz * intensity.x;
	Output.Color.w = 1.0;
    return Output;
}


technique Slice
{
    pass Pass0
    {        
        VertexShader = compile vs_3_0 VertexMapper();
        PixelShader = compile ps_3_0 SlicePixel();
    }
}